import graphviz as gv
import pandas as pd
import os
import numpy as np

def output_RIS(W,gene_names=None,output_file=None):
    W_df = pd.DataFrame(W,columns=gene_names,index=gene_names)
    RIS = W_df.stack().reset_index()
    RIS.columns = ['Regulator','Target gene','RIS']
    RIS = RIS[RIS['Regulator'] != RIS['Target gene']]
    RIS = RIS.sort_values(by='RIS',ascending=False)
    RIS.to_csv(output_file,header=False,index=False,sep='\t', float_format="%.6f")


def draw_network(score_file=None,outputfile=None,thr=0.5):
    score_df = pd.read_csv(score_file,sep="\t",header=None)
    score_df[2] = np.where(score_df[2]>=thr,1,0)

    g = gv.Digraph(engine='neato',format='png')
    g.graph_attr['overlap']='false'
    node_list = list(set(score_df[0].tolist()+score_df[1].tolist()))
    for node in node_list:
        g.node(node)

    for idx, row in score_df.iterrows():
        if int(row[2])==1:
            g.edge(row[0],row[1])

    g.render(filename=outputfile,view=False)
    os.remove(outputfile)