from btnet import *
from output import *
import numpy as np
import pandas as pd

input_files=["./data/IRMA_Switch-on/Switch-on_1.txt","./data/IRMA_Switch-on/Switch-on_2.txt","./data/IRMA_Switch-on/Switch-on_3.txt","./data/IRMA_Switch-on/Switch-on_4.txt","./data/IRMA_Switch-on/Switch-on_5.txt"]
output_ris_file="./IRMA_Switch-on_ris.tsv"
output_network_file="./IRMA_Switch-on_network"

TS_data_list =[]
for ts_file in input_files:
    TS_df = pd.read_csv(ts_file,sep="\t")
    TS_data_list.append(TS_df.as_matrix())
    gene_names = TS_df.columns.tolist()
    TS_data_list.append(TS_df.as_matrix())

TS_data= np.asarray(TS_data_list)
W= btnet(TS_data,boosting_method="GB",ntrees=100,K='all')
output_RIS(W,gene_names=gene_names,output_file=output_ris_file)
draw_network(output_ris_file,output_network_file,thr=0.3)